// test DLL.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "mtdv2DLL.h"
#pragma comment(lib,"DLLMTDV.lib")

void getInfoTest();
void getDataTest();
void setDataTest();
void memoryTest();
void otherTest();

int main()
{
	getInfoTest();
	getDataTest();
	setDataTest();
	memoryTest();
	otherTest();
    return 0;
}

void getInfoTest()
{
	MTDVDev dev;
	strcpy(dev.ip, "192.168.1.200");
	int response;
	unsigned int status;
	unsigned int error;
	unsigned int channelsCount;
	unsigned int parCount;
	response=getRawStatus(dev, status, error);
	response=getChannelsCount(dev, channelsCount);
	response=getParametersCount(dev, 5, parCount);
	char pn[MAXSTRINGL];
	unsigned int sn;
	char fwver[MAXSTRINGL];
	char macAdress[MAXSTRINGL];
	char ip[MAXSTRINGL];
	char subNetMask[MAXSTRINGL];
	float temperature;
	float vdd1;
	float vdd2;
	unsigned int homeCount;
	unsigned long int stepCount;
	response=getDevInfo(dev, pn, fwver, macAdress, ip, subNetMask, temperature, vdd1, vdd2);
	response=getChannelLog(dev, 5, fwver, homeCount, stepCount);
}

void getDataTest()
{
	MTDVDev dev;
	strcpy(dev.ip, "192.168.1.200");
	int response;
	MTDVData dataOutstruct;
	response=getData(dev, 0,5, dataOutstruct);
	response = getData(dev, 0, 200, dataOutstruct);
	char name[MAXSTRINGL];
	char unit[MAXSTRINGL];
	bool rw;
	unsigned int dataU;
	unsigned int dataUMin;
	unsigned int dataUMax;
	int dataI;
	int dataIMin;
	int dataIMax;
	float dataF;
	float dataFMin;
	float dataFMax;
	bool dataB;
	response = getUIntData(dev, 0, 3, name, unit, rw, dataU, dataUMin, dataUMax);
	response = getUIntData(dev, 0, 5, name, unit, rw, dataU, dataUMin, dataUMax);
	response = getFloatData(dev, 0, 3, name, unit, rw, dataF, dataFMin, dataFMax);
	response = getFloatData(dev, 0, 5, name, unit, rw, dataF, dataFMin, dataFMax);
	response = getBoolData(dev, 0, 11, name, unit, rw, dataB);
	response = getBoolData(dev, 0, 10, name, unit, rw, dataB);
	response = getIntData(dev, 0, 3, name, unit, rw, dataI, dataIMin, dataIMax);
	response = getIntData(dev, 0, 28, name, unit, rw, dataI, dataIMin, dataIMax);

}

void setDataTest()
{
	MTDVDev dev;
	strcpy(dev.ip, "192.168.1.200");
	int response; 
	unsigned int actualDataU;
	int actualDataI;
	float actualDataF;
	bool actualDataB;
	response = setBoolData(dev, 0, 11, true, actualDataB);
	response = setBoolData(dev, 0, 11, false, actualDataB);
	response = setBoolData(dev, 0, 3, 8, actualDataB);
}

void memoryTest()
{
	MTDVDev dev;
	strcpy(dev.ip, "192.168.1.200");
	int response;
	unsigned int actualDataU;
	char name[MAXSTRINGL];
	int p1, p2, p3, p4;
	response = saveCurrentPositions(dev, 1, 5, "test", actualDataU);
	response = loadPositionsAndMove(dev, 1, actualDataU, name);
	response = saveSpecificPositions(dev, 2,"test2", 1,1,3,4, actualDataU);
	response = loadPositions(dev, 2, name, actualDataU, p1, p2, p3, p4);
	
}

void otherTest()
{
	MTDVDev dev;
	strcpy(dev.ip, "192.168.1.200");
	int response;
	unsigned int actualDataU;
	char name[MAXSTRINGL];
	char name2[MAXSTRINGL];
	response = setChannelName(dev, 1, "ch 1", actualDataU, name2);
	response = getChannelName(dev, 0, actualDataU, name);
	float actualDataF1;
	float actualDataF2;
	unsigned int actualDataU1;
	unsigned int actualDataU2;
	int actualDataI1;
	int actualDataI2;
	response = setFloatDataLimit(dev, 0, 29, 20, 40, actualDataF1, actualDataF2);
	response = setUintDataLimit(dev, 0, 8, 1, 40, actualDataU1, actualDataU2);
	response = setIntDataLimit(dev, 0, 27, 1, 60, actualDataI1, actualDataI2);
}